# Couenne::exprGroup Class Reference

class Group, with constant, linear and nonlinear terms: More...

`#include <CouenneExprGroup.hpp>`

Inheritance diagram for Couenne::exprGroup:

List of all members.

## Public Types
typedef std::vector< std::pair < exprVar *, CouNumber > > | lincoeff
## Public Member Functions
| exprGroup (CouNumber, lincoeff &, expression **=NULL, int=0)
| Constructor.
| exprGroup (const exprGroup &src, Domain *d=NULL)
| Copy constructor.
virtual | ~exprGroup ()
| Destructor -- needed to clear bounds.
virtual expression * | clone (Domain *d=NULL) const
| Cloning method.
CouNumber | getc0 ()
| return constant term
lincoeff & | lcoeff () const
| return linear term coefficients
virtual void | print (std::ostream &=std::cout, bool=false) const
| Print expression to iostream.
virtual CouNumber | operator() ()
| function for the evaluation of the expression
virtual CouNumber | gradientNorm (const double *x)
| return l-2 norm of gradient at given point
virtual int | DepList (std::set< int > &deplist, enum dig_type type=ORIG_ONLY)
| fill in the set with all indices of variables appearing in the expression
virtual expression * | differentiate (int index)
| differentiation
virtual expression * | simplify ()
| simplification
virtual int | Linearity ()
| get a measure of "how linear" the expression is:
virtual void | getBounds (expression *&, expression *&)
| Get lower and upper bound of an expression (if any).
virtual void | getBounds (CouNumber &, CouNumber &)
| Get lower and upper bound of an expression (if any).
virtual void | generateCuts (expression *, OsiCuts &, const CouenneCutGenerator *, t_chg_bounds *=NULL, int=-1, CouNumber=-COUENNE_INFINITY, CouNumber=COUENNE_INFINITY)
| special version for linear constraints
virtual int | compare (exprGroup &)
| only compare with people of the same kind
virtual enum expr_type | code ()
| code for comparisons
virtual bool | isInteger ()
| is this expression integer?
virtual int | rank ()
| used in rank-based branching variable choice
virtual void | fillDepSet (std::set< DepNode *, compNode > *, DepGraph *)
| update dependence set with index of this variable
virtual void | replace (exprVar *x, exprVar *w)
| replace variable x with new (aux) w
virtual void | realign (const CouenneProblem *p)
| redirect variables to proper variable vector
## Static Public Member Functions
static expression * | genExprGroup (CouNumber, lincoeff &, expression **=NULL, int=0)
| Generalized (static) constructor: check parameters and return a constant, a single variable, or a real exprGroup.
## Protected Attributes
lincoeff | lcoeff_
| coefficients and indices of the linear term
CouNumber | c0_
| constant term

## Detailed Description

class Group, with constant, linear and nonlinear terms:

Definition at line 25 of file CouenneExprGroup.hpp.

## Member Typedef Documentation

typedef std::vector<std::pair <exprVar *, CouNumber> > Couenne::exprGroup::lincoeff

Definition at line 29 of file CouenneExprGroup.hpp.

## Constructor & Destructor Documentation

Couenne::exprGroup::exprGroup | ( | CouNumber | ,
|  | lincoeff & | ,
|  | expression ** | = `NULL`,
|  | int | = `0` |
| ) |  |  |

Constructor.

Referenced by clone().

Couenne::exprGroup::exprGroup | ( | const exprGroup & | src,
|  | Domain * | d = `NULL` |
| ) |  |  |

Copy constructor.

virtual Couenne::exprGroup::~exprGroup | ( |  | ) | `[virtual]`

Destructor -- needed to clear bounds.

## Member Function Documentation

static expression* Couenne::exprGroup::genExprGroup | ( | CouNumber | ,
|  | lincoeff & | ,
|  | expression ** | = `NULL`,
|  | int | = `0` |
| ) |  |  | `[static]`

Generalized (static) constructor: check parameters and return a constant, a single variable, or a real exprGroup.

virtual expression* Couenne::exprGroup::clone | ( | Domain * | d = `NULL` | ) | const`[inline, virtual]`

Cloning method.

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

Definition at line 58 of file CouenneExprGroup.hpp.

References exprGroup().

CouNumber Couenne::exprGroup::getc0 | ( |  | ) | `[inline]`

return constant term

Definition at line 62 of file CouenneExprGroup.hpp.

References c0_.

lincoeff& Couenne::exprGroup::lcoeff | ( |  | ) | const`[inline]`

return linear term coefficients

Definition at line 63 of file CouenneExprGroup.hpp.

References lcoeff_.

virtual void Couenne::exprGroup::print | ( | std::ostream & | = `std::cout`,
|  | bool | = `false` |
| ) |  |  | const`[virtual]`

Print expression to iostream.

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

CouNumber Couenne::exprGroup::operator() | ( |  | ) | `[inline, virtual]`

function for the evaluation of the expression

compute sum of linear and nonlinear terms

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

Definition at line 127 of file CouenneExprGroup.hpp.

References c0_, and lcoeff_.

virtual CouNumber Couenne::exprGroup::gradientNorm | ( | const double * | x | ) | `[virtual]`

return l-2 norm of gradient at given point

Reimplemented from Couenne::expression.

Reimplemented in Couenne::exprQuad.

virtual int Couenne::exprGroup::DepList | ( | std::set< int > & | deplist,
|  | enum dig_type | type = `ORIG_ONLY` |
| ) |  |  | `[virtual]`

fill in the set with all indices of variables appearing in the expression

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual expression* Couenne::exprGroup::differentiate | ( | int | index | ) | `[virtual]`

differentiation

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual expression* Couenne::exprGroup::simplify | ( |  | ) | `[virtual]`

simplification

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual int Couenne::exprGroup::Linearity | ( |  | ) | `[virtual]`

get a measure of "how linear" the expression is:

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::getBounds | ( | expression *& | ,
|  | expression *& |  |
| ) |  |  | `[virtual]`

Get lower and upper bound of an expression (if any).

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::getBounds | ( | CouNumber & | ,
|  | CouNumber & |  |
| ) |  |  | `[virtual]`

Get lower and upper bound of an expression (if any).

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::generateCuts | ( | expression * | ,
|  | OsiCuts & | ,
|  | const CouenneCutGenerator * | ,
|  | t_chg_bounds * | = `NULL`,
|  | int | = `-1`,
|  | CouNumber | = `-COUENNE_INFINITY`,
|  | CouNumber | = `COUENNE_INFINITY` |
| ) |  |  | `[virtual]`

special version for linear constraints

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

virtual int Couenne::exprGroup::compare | ( | exprGroup & |  | ) | `[virtual]`

only compare with people of the same kind

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual enum expr_type Couenne::exprGroup::code | ( |  | ) | `[inline, virtual]`

code for comparisons

Reimplemented from Couenne::exprSum.

Reimplemented in Couenne::exprQuad.

Definition at line 106 of file CouenneExprGroup.hpp.

References Couenne::COU_EXPRGROUP.

virtual bool Couenne::exprGroup::isInteger | ( |  | ) | `[virtual]`

is this expression integer?

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual int Couenne::exprGroup::rank | ( |  | ) | `[virtual]`

used in rank-based branching variable choice

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::fillDepSet | ( | std::set< DepNode *, compNode > * | ,
|  | DepGraph * |  |
| ) |  |  | `[virtual]`

update dependence set with index of this variable

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::replace | ( | exprVar * | x,
|  | exprVar * | w |
| ) |  |  | `[virtual]`

replace variable x with new (aux) w

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

virtual void Couenne::exprGroup::realign | ( | const CouenneProblem * | p | ) | `[virtual]`

redirect variables to proper variable vector

Reimplemented from Couenne::exprOp.

Reimplemented in Couenne::exprQuad.

## Member Data Documentation

lincoeff Couenne::exprGroup::lcoeff_`[mutable, protected]`

coefficients and indices of the linear term

Definition at line 33 of file CouenneExprGroup.hpp.

Referenced by lcoeff(), Couenne::exprQuad::Linearity(), and operator()().

CouNumber Couenne::exprGroup::c0_`[protected]`

constant term

Definition at line 34 of file CouenneExprGroup.hpp.

Referenced by getc0(), Couenne::exprQuad::Linearity(), and operator()().

The documentation for this class was generated from the following file:

- CouenneExprGroup.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines